/**
************************************************************************************************
* @文件    : uart3.c
* @作者    : 樊春春
* @版本    : V1.0
* @时间    : 2022/05/31 20:15:29
* @邮箱    : fanchcho@gmail.com
* @说明    : 485底层驱动
************************************************************************************************
**/

#include "uart6.h"

static uint8_t uart6_tx_buf[UART6_TX_LEN]  = {0};
static uint8_t uart6_rx_buf[UART6_REC_LEN] = {0};

UartFrame_TypeDef Uart6FrameStruct[UART6_MAX_MSG_NUM];

extern OS_EVENT *uart6_mbox;

void uart6_nvic_config(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;
    // Usart3 NVIC 配置
    NVIC_InitStructure.NVIC_IRQChannel                   = USART6_IRQn; //串口3中断通道
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;           //抢占优先级
    NVIC_InitStructure.NVIC_IRQChannelSubPriority        = 0;           //子优先级
    NVIC_InitStructure.NVIC_IRQChannelCmd                = ENABLE;      // IRQ通道使能
    NVIC_Init(&NVIC_InitStructure);
}

void uart6_dma_init(void)
{
    DMA_InitTypeDef DMA_InitStructure;
    if ((uint32_t)UART6_DMA_TXCH > (uint32_t)DMA2)
    {
        RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA2, ENABLE); // DMA2时钟使能
    }
    else
    {
        RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA1, ENABLE); // DMA1时钟使能
    }
    DMA_DeInit(UART6_DMA_TXCH);
    while (DMA_GetCmdStatus(UART6_DMA_TXCH) != DISABLE)
    {
    } //等待DMA可配置
    /* 配置 DMA Stream */
    DMA_InitStructure.DMA_Channel            = UART6_DMA;                   //通道选择
    DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&USART6->DR;       // DMA外设地址
    DMA_InitStructure.DMA_Memory0BaseAddr    = (uint32_t)uart6_tx_buf;      // DMA 存储器0地址
    DMA_InitStructure.DMA_DIR                = DMA_DIR_MemoryToPeripheral;  //存储器到外设模式
    DMA_InitStructure.DMA_BufferSize         = UART6_TX_LEN;                //数据传输量
    DMA_InitStructure.DMA_PeripheralInc      = DMA_PeripheralInc_Disable;   //外设非增量模式
    DMA_InitStructure.DMA_MemoryInc          = DMA_MemoryInc_Enable;        //存储器增量模式
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //外设数据长度:8位
    DMA_InitStructure.DMA_MemoryDataSize     = DMA_MemoryDataSize_Byte;     //存储器数据长度:8位
    DMA_InitStructure.DMA_Mode               = DMA_Mode_Normal;             // 使用普通模式
    DMA_InitStructure.DMA_Priority           = DMA_Priority_Medium;         //中等优先级6
    DMA_InitStructure.DMA_FIFOMode           = DMA_FIFOMode_Disable;
    DMA_InitStructure.DMA_FIFOThreshold      = DMA_FIFOThreshold_Full;
    DMA_InitStructure.DMA_MemoryBurst        = DMA_MemoryBurst_Single;     //存储器突发单次传输
    DMA_InitStructure.DMA_PeripheralBurst    = DMA_PeripheralBurst_Single; //外设突发单次传输
    DMA_Init(UART6_DMA_TXCH, &DMA_InitStructure);                          //初始化DMA Stream

    if ((uint32_t)UART6_DMA_RXCH > (uint32_t)DMA2) //得到当前stream是属于DMA2还是DMA1
    {
        RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA2, ENABLE); // DMA2时钟使能
    }
    else
    {
        RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_DMA1, ENABLE); // DMA1时钟使能
    }

    DMA_DeInit(UART6_DMA_RXCH);
    while (DMA_GetCmdStatus(UART6_DMA_RXCH) != DISABLE)
    {
    } //等待DMA可配置
    /* 配置 DMA Stream */
    DMA_InitStructure.DMA_Channel            = UART6_DMA;                   //通道选择
    DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&USART6->DR;       // DMA外设地址
    DMA_InitStructure.DMA_Memory0BaseAddr    = (uint32_t)uart6_rx_buf;      // DMA 存储器0地址
    DMA_InitStructure.DMA_DIR                = DMA_DIR_PeripheralToMemory;  //外设到存储器模式
    DMA_InitStructure.DMA_BufferSize         = UART6_REC_LEN;               //数据传输量
    DMA_InitStructure.DMA_PeripheralInc      = DMA_PeripheralInc_Disable;   //外设非增量模式
    DMA_InitStructure.DMA_MemoryInc          = DMA_MemoryInc_Enable;        //存储器增量模式
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //外设数据长度:8位
    DMA_InitStructure.DMA_MemoryDataSize     = DMA_MemoryDataSize_Byte;     //存储器数据长度:8位
    DMA_InitStructure.DMA_Mode               = DMA_Mode_Circular;           // 使用循环模式
    DMA_InitStructure.DMA_Priority           = DMA_Priority_Medium;         //中等优先级
    DMA_InitStructure.DMA_FIFOMode           = DMA_FIFOMode_Disable;
    DMA_InitStructure.DMA_FIFOThreshold      = DMA_FIFOThreshold_Full;
    DMA_InitStructure.DMA_MemoryBurst        = DMA_MemoryBurst_Single;     //存储器突发单次传输
    DMA_InitStructure.DMA_PeripheralBurst    = DMA_PeripheralBurst_Single; //外设突发单次传输
    DMA_Init(UART6_DMA_RXCH, &DMA_InitStructure);
}

void uart6_config(void)
{
    USART_InitTypeDef USART_InitStructure;
    USART_InitStructure.USART_BaudRate            = 9600;                           //波特率设置
    USART_InitStructure.USART_WordLength          = USART_WordLength_8b;            //字长为8位数据格式
    USART_InitStructure.USART_StopBits            = USART_StopBits_1;               //一个停止位
    USART_InitStructure.USART_Parity              = USART_Parity_No;                //无奇偶校验位
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //无硬件数据流控制
    USART_InitStructure.USART_Mode                = USART_Mode_Rx | USART_Mode_Tx;  //收发模式
    USART_Init(USART6, &USART_InitStructure);                                       //初始化串口1

    USART_Cmd(USART6, ENABLE); //使能串口3
}

void Uart6DMA_Enable(DMA_Stream_TypeDef *DMA_Streamx, u16 count)
{
    DMA_Cmd(DMA_Streamx, DISABLE); //关闭DMA传输
    while (DMA_GetCmdStatus(DMA_Streamx) != DISABLE)
    {
    } //确保DMA可以被设置

    DMA_SetCurrDataCounter(DMA_Streamx, count); //数据传输量
    DMA_Cmd(DMA_Streamx, ENABLE);               //开启DMA传输
}

void uart6_init(void)
{
    uart6_config();
    uart6_dma_init();
    uart6_nvic_config();
    /* USART DMA enable*/
    USART_DMACmd(USART6, USART_DMAReq_Rx, ENABLE); // 使能串口DMA接收数据
    Uart6DMA_Enable(UART6_DMA_RXCH, UART6_REC_LEN);

    /*configure DMA interrupt*/
    USART_ITConfig(USART6, USART_IT_IDLE, ENABLE); //开启空闲中断
    USART_ITConfig(USART6, USART_IT_TC, ENABLE);

    // UART6_RX_ENABLE;
}

/****************************************************
 *  函 数 名：Uart6_Send_Data
 *  函数功能：串口3发送数据
 *  入口参数：buf 待发送数据  len 数据长度
 *  说    明：
 *****************************************************/
void Uart6_Send_Data(const uint8_t *buf, uint16_t len)
{
    uint8_t i;

    // UART6_TX_ENABLE;          // 485 发送使能
    for (i = 0; i < len; i++) //循环发送数据
    {
        while (USART_GetFlagStatus(USART6, USART_FLAG_TC) == RESET)
            ;
        USART_SendData(USART6, buf[i]);
    }
    while (USART_GetFlagStatus(USART6, USART_FLAG_TC) == RESET)
        ;

    // UART6_RX_ENABLE; // 接收使能
}

void uart6_dma_send(const uint8_t *buf, uint16_t len)
{
    if (DMA_GetFlagStatus(UART6_DMA_TXCH, DMA_FLAG_TCIF3) != RESET)
    {
        DMA_ClearFlag(UART6_DMA_TXCH, DMA_FLAG_TCIF3);
    }

    // UART6_TX_ENABLE; // 485 发送使能
    if (len > UART6_TX_LEN)
    {
        len = UART6_TX_LEN;
    }
    memcpy(uart6_tx_buf, buf, len);
    USART_DMACmd(USART6, USART_DMAReq_Tx, len);
    Uart6DMA_Enable(UART6_DMA_TXCH, len);
}

void USART6_IRQHandler(void)
{
    static uint8_t   u3_index = 0;
    volatile uint8_t clear    = 0;
    uint8_t          rec_cnt  = 0;
    if (RESET != USART_GetITStatus(USART6, USART_IT_IDLE))
    {
        clear = USART6->SR;
        clear = USART6->DR; // 先读SR, 再读DR, 就是为了消除IDLE中断
        DMA_Cmd(UART6_DMA_RXCH, DISABLE);
        DMA_ClearFlag(UART6_DMA_RXCH, DMA_FLAG_TCIF1);
        rec_cnt = UART6_REC_LEN - DMA_GetCurrDataCounter(UART6_DMA_RXCH);

        memcpy(Uart6FrameStruct[u3_index].buf, uart6_rx_buf, rec_cnt);
        Uart6FrameStruct[u3_index].len = rec_cnt;

        OSMboxPost(uart6_mbox, &Uart6FrameStruct[u3_index]);
        if (u3_index < UART6_MAX_MSG_NUM - 1)
        {
            u3_index++;
        }
        else
        {
            u3_index = 0;
        }
        DMA_SetCurrDataCounter(UART6_DMA_RXCH, UART6_REC_LEN);
        DMA_Cmd(UART6_DMA_RXCH, ENABLE);
    }
    else if (RESET != USART_GetITStatus(USART6, USART_IT_TC))
    {
        USART_ClearITPendingBit(USART6, USART_IT_TC);
        // UART6_RX_ENABLE;
        Uart6DMA_Enable(UART6_DMA_RXCH, UART6_REC_LEN); // DMA接收使能
        DMA_Cmd(UART6_DMA_TXCH, DISABLE);               // 关闭发送DMA
        DMA_SetCurrDataCounter(UART6_DMA_TXCH, 0);      // 清除发送数据长度
    }
}
